commit e9c2c61b9157e15311dbf0a73c575ae0eae79cb3
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Sat Oct 10 21:22:12 2020 +0100

    libstdc++: Replace use of reserved name that clashes [PR 97362]
    
    The name __deref is defined as a macro by Windows headers.
    
    This renames the __deref() helper function to __ref. It doesn't actually
    dereference an iterator. it just has the same type as the iterator's
    reference type.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/97362
            * doc/html/manual/source_code_style.html: Regenerate.
            * doc/xml/manual/appendix_contributing.xml: Add __deref to
            BADNAMES.
            * include/debug/functions.h (_Irreflexive_checker::__deref):
            Rename to __ref.
            * testsuite/17_intro/badnames.cc: Check __deref.
    
    (cherry picked from commit 2137aa92412da363d52ef699987441be28b239d0)

diff --git a/libstdc++-v3/include/debug/functions.h b/libstdc++-v3/include/debug/functions.h
index aaccc8dfe07..942d35f358d 100644
--- a/libstdc++-v3/include/debug/functions.h
+++ b/libstdc++-v3/include/debug/functions.h
@@ -421,10 +421,10 @@ namespace __gnu_debug
   {
     template<typename _It>
       static typename std::iterator_traits<_It>::reference
-      __deref();
+      __ref();
 
     template<typename _It,
-	     typename = decltype(__deref<_It>() < __deref<_It>())>
+	     typename = decltype(__ref<_It>() < __ref<_It>())>
       _GLIBCXX20_CONSTEXPR
       static bool
       _S_is_valid(_It __it)
@@ -438,7 +438,7 @@ namespace __gnu_debug
       { return true; }
 
     template<typename _It, typename _Pred, typename
-	= decltype(std::declval<_Pred>()(__deref<_It>(), __deref<_It>()))>
+	= decltype(std::declval<_Pred>()(__ref<_It>(), __ref<_It>()))>
       _GLIBCXX20_CONSTEXPR
       static bool
       _S_is_valid_pred(_It __it, _Pred __pred)
diff --git a/libstdc++-v3/testsuite/17_intro/badnames.cc b/libstdc++-v3/testsuite/17_intro/badnames.cc
index c69b8c45d81..a6b98db26f2 100644
--- a/libstdc++-v3/testsuite/17_intro/badnames.cc
+++ b/libstdc++-v3/testsuite/17_intro/badnames.cc
@@ -62,6 +62,7 @@
 
 // MS adds:
 #define _T		_T is a BADNAME
+#define __deref		__deref is a BADNAME
 
 // BSD adds:
 #define __used		__used is a BADNAME

